%Script 2 for Model- Ang-Tie interactions
%FULL MODEL - Ang1, Ang2, sTie2

function [ dx ] = ModelODEs_Thesis( t, x )
%function to return the derivatives of the state variables for the Ang-Tie
%model

% parameters take values from main script (global)

global k1;
global k_1;
global k2; 
global k_2;
global k3;
global k_3;
global k4;
global k_4;
global k5;
global k_5;
%global V6; %dephos
%global K6; %dephos
global k7;
global k8;

global k9;
global k10;
global k11;
global k12;

global k13;

global k14;
global k_14;

global k15;
global k_15;

global k16;
global k_16;
global k17;
global k_17;

global k18;
global k_18;
global k19;
global k_19;
global k20;
global k_20;

global k21;
global k_21;
global k22;
global k_22;
global k23;
global k_23;
global k24;
global k_24;
global k25;
global k_25;
%global V26; %dephos
%global K26; %dephos

global k27;
global k_27
global k28;
global k_28
global k29;
global k_29;

global k30;
global k_30;
global k31;
global k_31;
global k32;
global k_32;

% calculate reaction rates

r1 = k1*x(1)*x(2) - k_1*x(3); %Ang1 binding to Tie2 MONOMER
r2 = k2*(x(3)*2800000)*(x(2)*2800000) - k_2*x(4); %DIMER
r3 = k3*x(4)*(x(2)*2800000) - k_3*x(5); %TRIMER
r4 = k4*x(5)*(x(2)*2800000) - k_4*x(6);%TETRAMER
r5 = k5*x(6) - k_5*x(7); %PHOSPHORYLATION
%r6 = (V6*x(7))/(K6 + x(7)); %%%dephosphorylation%%%
r7 = k7*x(7); %internalization
r8 = k8*x(8); %degradation of pTie2

r9 = k9*x(3); %iTie2 mono Ang1
r10 = k10*x(4); %iTie2 di Ang1
r11 = k11*x(5); %iTie2 tri Ang1
r12 = k12*x(6); %iTie2 tetra Ang1

r13 = k13*x(14); %replenishment
r14 = k14*(x(15)*2800000)*(x(2)*2800000) - k_14*x(16); %Tie1:Tie2

r15 = k15*x(1)*x(17) - k_15*x(18); %Ang1 binding to sTie2 MONOMER

r16 = k16*x(19)*x(2) - k_16*x(20); %(Ang2)2 binding to Tie2 MONOMER
r17 = k17*(x(20)*2800000)*(x(2)*2800000) - k_17*x(21); %DIMER

r18 = k18*x(22)*x(2) - k_18*x(23); %(Ang2)3 binding to Tie2 MONOMER
r19 = k19*(x(23)*2800000)*(x(2)*2800000) - k_19*x(24); %DIMER
r20 = k20*x(24)*(x(2)*2800000) - k_20*x(25); %TRIMER

r21 = k21*x(26)*x(2) - k_21*x(27); %(Ang2)4 binding to Tie2 MONOMER
r22 = k22*(x(27)*2800000)*(x(2)*2800000) - k_22*x(28); %DIMER
r23 = k23*x(28)*(x(2)*2800000) - k_23*x(29); %TRIMER
r24 = k24*x(29)*(x(2)*2800000) - k_24*x(30);%TETRAMER
r25 = k25*x(30) - k_25*x(31); %PHOSPHORYLATION
%r26 = (V26*x(31))/(K26 + x(31)); %%%dephosphorylation%%%

r27 = k27*x(19)*(x(16)/2800000) - k_27*x(32); %(Ang2)2 binding to Tie1:Tie2
r28 = k28*x(22)*(x(16)/2800000) - k_28*x(33); %(Ang2)3 binding to Tie1:Tie2
r29 = k29*x(26)*(x(16)/2800000) - k_29*x(34); %(Ang2)4 binding to Tie1:Tie2

r30 = k30*x(19)*x(17) - k_30*x(35); %(Ang2)2 binding to Tie1:Tie2
r31 = k31*x(22)*x(17) - k_31*x(36); %(Ang2)3 binding to Tie1:Tie2
r32 = k32*x(26)*x(17) - k_32*x(37); %(Ang2)4 binding to Tie1:Tie2


% calculate derivates
dx = zeros(37,1);
dx(1) = -r1-r15; % Ang1
dx(2) = -r1-r2-r3-r4+r13-r14-r16-r17-r18-r19-r20-r21-r22-r23-r24; % Tie2

dx(3) = r1-r2-r9; % Monomer
dx(4) = r2-r3-r10; % Dimer
dx(5) = r3-r4-r11; % Trimer
%dx(6) = r4-r5+r6-r12; % Tetramer with dephos ++
dx(6) = r4-r5-r12; % Tetramer without dephos --
%dx(7) = r5-r6-r7; % Phosho-Tie2 with dephos ++
dx(7) = r5-r7; % Phosho-Tie2 without dephos --
dx(8) = r7-r8; % internalized pTie2
dx(9) = r8; % degraded pTie2

dx(10) = r9; % iTie2 mono Ang1
dx(11) = r10; % iTie2 di Ang1
dx(12) = r11; % iTie2 tri Ang1
dx(13) = r12; % iTie2 tetra Ang1

dx(14) = -r13; % New Tie2

dx(15) = -r14; % Tie1
dx(16) = r14-r27-r28-r29; % Tie1:Tie2

dx(17) = -r15-r30-r31-r32; % sTie2
dx(18) = r15; % Ang1-sTie2

dx(19) = -r16-r27-r30; % (Ang)2
dx(20) = r16-r17; % (Ang2)2 Monomer
dx(21) = r17; % Dimer

dx(22) = -r18-r28-r31; % (Ang)3
dx(23) = r18-r19; % (Ang2)3 Monomer
dx(24) = r19-r20; % Dimer
dx(25) = r20; % Trimer

dx(26) = -r21-r29-r32; % (Ang)4
dx(27) = r21-r22; % (Ang2)4 Monomer
dx(28) = r22-r23; % Dimer
dx(29) = r23-r24; % Trimer
%dx(30) = r24-r25+r26; % Tetramer with dephos ++
dx(30) = r24-r25; % Tetramer without dephos --
%dx(31) = r25-r26; % Phosho-Tie2 with dephos ++
dx(31) = r25; % Phosho-Tie2 without dephos --

dx(32) = r27; % (Ang2)2-Tie1:Tie2
dx(33) = r28; % (Ang2)3-Tie1:Tie2
dx(34) = r29; % (Ang2)4-Tie1:Tie2

dx(35) = r30; % (Ang2)2-sTie2
dx(36) = r31; % (Ang2)3-sTie2
dx(37) = r32; % (Ang2)4-sTie2

end